VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4875
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5430
   LinkTopic       =   "Form1"
   ScaleHeight     =   4875
   ScaleWidth      =   5430
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdRun 
      Caption         =   "Run"
      Height          =   375
      Left            =   4680
      TabIndex        =   8
      Top             =   240
      Width           =   615
   End
   Begin VB.CommandButton cmdSetSystem 
      Caption         =   "Set"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4680
      TabIndex        =   7
      Top             =   3840
      Width           =   615
   End
   Begin VB.FileListBox filSystem 
      Height          =   1650
      Left            =   120
      Pattern         =   "*.scr"
      TabIndex        =   5
      Top             =   3120
      Width           =   4455
   End
   Begin VB.CommandButton cmdSetWindows 
      Caption         =   "Set"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4680
      TabIndex        =   4
      Top             =   1800
      Width           =   615
   End
   Begin VB.FileListBox filWindows 
      Height          =   1650
      Left            =   120
      Pattern         =   "*.scr"
      TabIndex        =   2
      Top             =   1080
      Width           =   4455
   End
   Begin VB.Label Label1 
      Caption         =   "System Directory Screen Savers"
      Height          =   255
      Index           =   2
      Left            =   120
      TabIndex        =   6
      Top             =   2880
      Width           =   2535
   End
   Begin VB.Label Label1 
      Caption         =   "Windows Directory Screen Savers"
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   3
      Top             =   840
      Width           =   2535
   End
   Begin VB.Label lblScreenSaver 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   360
      Width           =   4455
   End
   Begin VB.Label Label1 
      Caption         =   "Current Screen Saver"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1575
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Private Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function GetShortPathName Lib "kernel32" Alias "GetShortPathNameA" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Const WM_SYSCOMMAND = &H112
Private Const SC_SCREENSAVE = &HF140&

Private Function GetIniString(ByVal file_name As String, ByVal section As String, ByVal key_name As String, ByVal default As String) As String
Const MAX_LEN As Integer = 2408
Dim ret_buffer As String
Dim ret_len As Long

    ret_buffer = Space$(MAX_LEN)
    ret_len = GetPrivateProfileString( _
        section, key_name, default, _
        ret_buffer, Len(ret_buffer), file_name)
    GetIniString = Left$(ret_buffer, ret_len)
End Function
Private Sub SetIniString(ByVal file_name As String, ByVal section As String, ByVal key_name As String, ByVal value As String)
    WritePrivateProfileString section, key_name, _
        value, file_name
End Sub
' Return the System directory path.
Private Function GetSystemDir() As String
Const MAX_PATH_LEN As Integer = 260
Dim win_dir As String
Dim ret_len As Long

    ' Get the windows directory.
    win_dir = Space$(MAX_PATH_LEN)
    ret_len = GetSystemDirectory( _
        win_dir, Len(win_dir))
    GetSystemDir = Left$(win_dir, ret_len)
End Function

' Return the Windows directory path.
Private Function GetWindowsDir() As String
Const MAX_PATH_LEN As Integer = 260
Dim win_dir As String
Dim ret_len As Long

    ' Get the windows directory.
    win_dir = Space$(MAX_PATH_LEN)
    ret_len = GetWindowsDirectory( _
        win_dir, Len(win_dir))
    GetWindowsDir = Left$(win_dir, ret_len)
End Function

' Display the current screen saver.
Private Sub ShowScreenSaver()
Dim screen_saver As String

    screen_saver = GetIniString( _
        GetWindowsDir() & "\System.ini", _
        "boot", "SCRNSAVE.EXE", "<none>")
    lblScreenSaver.Caption = screen_saver
End Sub

Private Sub cmdRun_Click()
    SendMessage hwnd, WM_SYSCOMMAND, SC_SCREENSAVE, ByVal 0&
End Sub

Private Sub cmdSetSystem_Click()
Dim screen_saver As String

    screen_saver = ShortFileName( _
        GetSystemDir() & "\" & filSystem.FileName)
    SetIniString _
        GetWindowsDir() & "\System.ini", _
        "boot", "SCRNSAVE.EXE", screen_saver

    ShowScreenSaver
End Sub

Private Sub cmdSetWindows_Click()
Dim screen_saver As String

    screen_saver = ShortFileName( _
        GetWindowsDir() & "\" & filWindows.FileName)
    SetIniString _
        GetWindowsDir() & "\System.ini", _
        "boot", "SCRNSAVE.EXE", screen_saver

    ShowScreenSaver
End Sub
' Return the short file name for a long file name.
Public Function ShortFileName(ByVal long_name As String) As String
Dim length As Long
Dim short_name As String

    short_name = Space$(1024)
    length = GetShortPathName( _
        long_name, short_name, _
        Len(short_name))
    ShortFileName = Left$(short_name, length)
End Function

Private Sub filSystem_Click()
    cmdSetSystem.Enabled = (filSystem.ListIndex <> -1)
End Sub

Private Sub filWindows_Click()
    cmdSetWindows.Enabled = (filWindows.ListIndex <> -1)
End Sub

Private Sub Form_Load()
    ' List screen saver files.
    filWindows.Path = GetWindowsDir()
    filSystem.Path = GetSystemDir()

    ShowScreenSaver
End Sub

